diff --git a/src/port/rint.c b/src/port/rint.c
index 9c4d775..1349317 100644
--- a/src/port/rint.c
+++ b/src/port/rint.c
@@ -15,5 +15,20 @@
 double
 rint(double x)
 {
-	return (x >= 0.0) ? floor(x + 0.5) : ceil(x - 0.5);
+	double r;
+	if (x <= 0.0)
+	{
+		if (x == 0.0)
+			return x;
+		r = floor(x += 0.5);
+		if (r != x || x == 0.0)
+			return x >= 0.0 ? -0.0 : r;
+		return floor(x * 0.5) * 2.0;
+	}
+
+	r = ceil(x -= 0.5);
+	if (r != x)
+		return x <= 0.0 ? 0.0 : r;
+
+	return ceil(x * 0.5) * 2.0;
 }
